/*
 *  rsql_plugin.c
 *
 *  Created by Marco Bambini on 1/5/08.
 *  Copyright 2005-2008 REALSoftware, Inc. All rights reserved.
 * 
 *  DO NOT EDIT THIS FILE!
 */

#include "rsql_plugin.h"

static PluginResolver *gresolver;

#pragma mark -

int rsql_plugin_main (PluginResolver *resolver)
{	
	gresolver = resolver;
	return RSQL_API_VESION;
}

//  main functions (5)
int rsql_register_sql_function  (void *pluginref, char *name, int num_args, int text_encoding, void *user_data, void (*xFunc)(rsql_context *ctx, int argc, rsql_value **argv))
{
	return gresolver->rsql_register_sql_function (pluginref, name, num_args, text_encoding, user_data, xFunc);
}

int rsql_register_sql_aggregate (void *pluginref, char *name, int num_args, int text_encoding, void *user_data, void (*xStep)(rsql_context *ctx, int argc, rsql_value **argv), void (*xFinal)(rsql_context *ctx))
{
	return gresolver->rsql_register_sql_aggregate (pluginref, name, num_args, text_encoding, user_data, xStep, xFinal);
}

int rsql_register_sql_collation (void *pluginref, char *name, int text_encoding, void *user_data, int(*xCompare)(void *user_data, int len1, const void *str1, int len2, const void *str2), void(*xDestroy)(void *user_data))
{
	return gresolver->rsql_register_sql_collation (pluginref, name, text_encoding, user_data, xCompare, xDestroy);
}

int rsql_register_command (void *pluginref, char *command, int invisible, int dbref_required, int context, int commandID, int privilegeCode, int (*xCommand)(rsql_client *client, const char **args, int commandID))
{
	return gresolver->rsql_register_command (pluginref, command, invisible, dbref_required, context, commandID, privilegeCode, xCommand);
}

int rsql_register_protocol (void *pluginref, int command, int bitfield, int (*xProtocol)(rsql_client *client))
{
	return gresolver->rsql_register_protocol (pluginref, command, bitfield, xProtocol);
}

#pragma mark -

// timer (3)
void rsql_timer_start (rsql_timer *t)
{
	gresolver->rsql_timer_start (t);
}

void rsql_timer_end (rsql_timer *t)
{
	gresolver->rsql_timer_end (t);
}

double rsql_timer_value (rsql_timer *t)
{
	return gresolver->rsql_timer_value (t);
}

#pragma mark -

// utils (16)
int rsql_file_copy (char *dest, char *src)
{
	return gresolver->rsql_file_copy (dest, src);
}

int rsql_file_delete (char *path)
{
	return gresolver->rsql_file_delete (path);
}

int rsql_file_exists (const char *path)
{
	return gresolver->rsql_file_exists (path);
}

int rsql_file_rename (const char *oldname, const char *newname)
{
	return gresolver->rsql_file_rename (oldname, newname);
}

int rsql_file_write (char *file_path, char *buffer, int len)
{
	return gresolver->rsql_file_write (file_path, buffer, len);
}

int rsql_path_is_directory (char *path)
{
	return gresolver->rsql_path_is_directory (path);
}

void rsql_path_build (char *path, char *path1, const char *path2)
{
	gresolver->rsql_path_build (path, path1, path2);
}

int rsql_directory_create (char *path)
{
	return gresolver->rsql_directory_create (path);
}

DIRREF rsql_dir_init (char *dirpath)
{
	return gresolver->rsql_dir_init (dirpath);
}

char* rsql_dir_read (DIRREF dref)
{
	return gresolver->rsql_dir_read (dref);
}

void rsql_log (char *msg)
{
	gresolver->rsql_log(msg);
}

int rsql_num_processors (void)
{
	return gresolver->rsql_num_processors();
}

char* rsql_ip_address (void)
{
	return gresolver->rsql_ip_address ();
}

char* rsql_os_version (char *buf, int len)
{
	return gresolver->rsql_os_version (buf, len);
}

char* rsql_compress_buffer (char *buffer1, int buffer1Size, char *buffer2, int buffer2Size, int *compressedSize)
{
	return gresolver->rsql_compress_buffer (buffer1, buffer1Size, buffer2, buffer2Size, compressedSize);
}

void rsql_client_set_error (rsql_client *client, int errcode, char *errmsg)
{
	gresolver->rsql_client_set_error(client, errcode, errmsg);
}

#pragma mark -

// preferences (3)
char* rsql_pref_read (char *key, char *domain, char *buffer, int blen)
{
	return gresolver->rsql_pref_read(key, domain, buffer, blen);
}

int rsql_pref_write (char *key, char *value, char *domain)
{
	return gresolver->rsql_pref_write(key, value, domain);
}

int rsql_pref_delete (char *key, char *domain)
{
	return gresolver->rsql_pref_delete(key, domain);
}

#pragma mark -

// db (10)
rsql_db* rsql_db_create_inmemory (void)
{
	return gresolver->rsql_db_create_inmemory();
}

rsql_db* rsql_db_open (char *name, char *key, int *flag)
{
	return gresolver->rsql_db_open (name, key, flag);
}

void rsql_db_close (rsql_db *db)
{
	gresolver->rsql_db_close (db);
}

int rsql_db_write (rsql_db *db, char *sql)
{
	return gresolver->rsql_db_write (db, sql);
}

int rsql_db_read_table (rsql_db *db, char *sql, char ***result, int *nrows, int *ncolumns)
{
	return gresolver->rsql_db_read_table (db, sql, result, nrows, ncolumns);
}

void rsql_db_free_table (char **result)
{
	gresolver->rsql_db_free_table (result);
}

char* rsql_db_column_read (rsql_db *db, char *sql, int colnum, char *buffer, int blen)
{
	return gresolver->rsql_db_column_read (db, sql, colnum, buffer, blen);
}

void rsql_db_send_cursor (rsql_db *db, char *sql, rsql_client *client)
{
	gresolver->rsql_db_send_cursor(db, sql, client);
}

int rsql_db_errcode (rsql_db *db)
{
	return gresolver->rsql_db_errcode (db);
}

char* rsql_db_errmsg (rsql_db *db)
{
	return gresolver->rsql_db_errmsg (db);
}

#pragma mark -

// string (9)
int rsql_strcmpi (const char *s1, const char *s2)
{
	return gresolver->rsql_strcmpi (s1, s2);
}

int rsql_strncmpi (const char *s1, const char *s2, int i)
{
	return gresolver->rsql_strncmpi (s1, s2, i);
}

char* rsql_strdup (const char *s)
{
	return gresolver->rsql_strdup (s);
}

char* rsql_strndup (const char *s, size_t n)
{
	return gresolver->rsql_strndup (s, n);
}

char* rsql_strtrim (char *s)
{
	return gresolver->rsql_strtrim (s);
}

int rsql_strncasecmp (const char *s1, const char *s2, size_t n)
{
	return gresolver->rsql_strncasecmp (s1, s2, n);
}

char* rsql_strcasestr (const char *s, const char *find)
{
	return gresolver->rsql_strcasestr (s, find);
}

char* rsql_strlowercase (char *s)
{
	return gresolver->rsql_strlowercase (s);
}

char* rsql_struppercase (char *s)
{
	return gresolver->rsql_struppercase (s);
}

#pragma mark -

// sqlite (32)
void *rsql_user_data (rsql_context *ctx)
{
	return gresolver->rsql_user_data (ctx);
}

void *rsql_aggregate_context (rsql_context* ctx, int nbytes)
{
	return gresolver->rsql_aggregate_context (ctx, nbytes);
}

void *rsql_malloc (int dim)
{
	return gresolver->rsql_malloc(dim);
}

void *rsql_realloc (void *p, int nbytes)
{
	return gresolver->rsql_realloc (p, nbytes);
}

void rsql_free (void *p)
{
	gresolver->rsql_free(p);
}

const void *rsql_value_blob (rsql_value *param)
{
	return gresolver->rsql_value_blob(param);
}

int rsql_value_bytes (rsql_value *param)
{
	return gresolver->rsql_value_bytes(param);
}

int rsql_value_bytes16 (rsql_value *param)
{
	return gresolver->rsql_value_bytes16(param);
}

double rsql_value_double (rsql_value *param)
{
	return gresolver->rsql_value_double(param);
}

int rsql_value_int (rsql_value *param)
{
	return gresolver->rsql_value_int(param);
}

rsql_int64 rsql_value_int64 (rsql_value *param)
{
	return gresolver->rsql_value_int64(param);
}

const unsigned char *rsql_value_text (rsql_value *param)
{
	return gresolver->rsql_value_text(param);
}

const void *rsql_value_text16 (rsql_value *param)
{
	return gresolver->rsql_value_text16(param);
}

const void *rsql_value_text16le (rsql_value *param)
{
	return gresolver->rsql_value_text16le(param);
}

const void *rsql_value_text16be (rsql_value *param)
{
	return gresolver->rsql_value_text16be(param);
}

int rsql_value_type (rsql_value *param)
{
	return gresolver->rsql_value_type(param);
}

int rsql_value_numeric_type (rsql_value *param)
{
	return gresolver->rsql_value_numeric_type(param);
}

void rsql_result_blob (rsql_context* ctx, const void *data, int len, void(*p)(void*))
{
	gresolver->rsql_result_blob(ctx, data, len, p);
}

void rsql_result_double (rsql_context* ctx, double value)
{
	gresolver->rsql_result_double(ctx, value);
}

void rsql_result_error (rsql_context* ctx, const char *s, int len)
{
	gresolver->rsql_result_error(ctx, s, len);
}

void rsql_result_error16 (rsql_context* ctx, const void *s, int len)
{
	gresolver->rsql_result_error16 (ctx, s, len);
}

void rsql_result_error_toobig (rsql_context* ctx)
{
	gresolver->rsql_result_error_toobig(ctx);
}

void rsql_result_error_nomem (rsql_context* ctx)
{
	gresolver->rsql_result_error_nomem(ctx);
}

void rsql_result_int (rsql_context* ctx, int value)
{
	gresolver->rsql_result_int(ctx, value);
}

void rsql_result_int64 (rsql_context* ctx, rsql_int64 value)
{
	gresolver->rsql_result_int64(ctx, value);
}

void rsql_result_null (rsql_context* ctx)
{
	gresolver->rsql_result_null(ctx);
}

void rsql_result_text (rsql_context* ctx, const char *s, int len, void(*p)(void*))
{
	gresolver->rsql_result_text(ctx, s, len, p);
}

void rsql_result_text16 (rsql_context* ctx, const void *s, int len, void(*p)(void*))
{
	gresolver->rsql_result_text16(ctx, s, len, p);
}

void rsql_result_text16le (rsql_context* ctx, const void *s, int len, void(*p)(void*))
{
	gresolver->rsql_result_text16le(ctx, s, len, p);
}

void rsql_result_text16be (rsql_context* ctx, const void *s, int len, void(*p)(void*))
{
	gresolver->rsql_result_text16be(ctx, s, len, p);
}

void rsql_result_value (rsql_context* ctx, rsql_value *param)
{
	gresolver->rsql_result_value (ctx, param);
}

void rsql_result_zeroblob (rsql_context* ctx, int n)
{
	gresolver->rsql_result_zeroblob (ctx, n);
}

