#!/bin/sh
INSTALL_DIR=/opt/realsoftware/realserver

# check if installation folder exists
if ! [ -d  $INSTALL_DIR ]; then
mkdir -p $INSTALL_DIR
fi

# copy from data to $INSTALL_DIR
cp -fR ./data/realserver/* $INSTALL_DIR
chown root:root "$INSTALL_DIR/realserver"

# copy startup script
# MUST be root:root
# some distributions doesn't have the rc.d subdirectory
INIT_DIR=/etc/rc.d/init.d
if ! [ -d  $INIT_DIR ]; then
INIT_DIR=/etc/init.d
fi

STARTUP_DIR=/etc/rc.d
if ! [ -d  $STARTUP_DIR ]; then
STARTUP_DIR=/etc
fi

cp ./data/realserver.startup "$INIT_DIR/realserver"
chown root:root "$INIT_DIR/realserver"

# to make the script be run on machine start up we need to create a symbolic link to it
ln -fs "$INIT_DIR/realserver" "$STARTUP_DIR/rc3.d/S86realserver"
ln -fs "$INIT_DIR/realserver" "$STARTUP_DIR/rc5.d/S86realserver"

# now the links to make realserver shut down
ln -fs "$INIT_DIR/realserver" "$STARTUP_DIR/rc0.d/K86realserver"
ln -fs "$INIT_DIR/realserver" "$STARTUP_DIR/rc6.d/K86realserver"
